import { Filter, MatchingAlgorithms } from "../../generated/prisma";

export const any = (filter: Filter, input: string) => {
    for (let word in input.split(" ")) {
        word = filter.is_insensitive ? word.toLowerCase() : word;
        const against = filter.is_insensitive ? filter.value.toLowerCase() : filter.value;

        if (word.includes(against)) return true;
    }

    return false;
};

export const all = (filter: Filter, input: string) => {
    return true;
};

export const literal = (filter: Filter, input: string) => {
    return true;
};

export const regex = (filter: Filter, input: string) => {
    return true;
};

export const fuzzy = (filter: Filter, input: string) => {
    return true;
};

export const mapAlgorithmToFunction = (filter: Filter, input: string) => {
    switch (filter.matching_algorithm) {
        case MatchingAlgorithms.ALL: return all(filter, input);
        case MatchingAlgorithms.ANY: return any(filter, input);
        case MatchingAlgorithms.EXACT: return literal(filter, input);
        case MatchingAlgorithms.REGEX: return regex(filter, input);
        case MatchingAlgorithms.FUZZY: return fuzzy(filter, input);
        default:
            throw new Error(`Unknown algorithm: ${filter.matching_algorithm}`);
    }
};